<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Admin</title>

    <style>
      body {
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
      }
      form {
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        margin: 40px;
      }
      th,
      td {
        padding: 0 40px;
      }

      th {
        color: white;
        background-color: gray;
      }

      td {
        border: 1px solid gray;
      }

      input {
        margin-bottom: 10px;
      }

      #log-out {
        margin: 50px 0;
      }
    </style>
  </head>
  <body>
    <form id="login-form">
      Login as admin:
      <input type="email" placeholder="email" autocomplete="off" />
      <input type="password" placeholder="password" autocomplete="off" />
      <button>Login</button>
    </form>

    <form id="add-form">
      Add new:
      <input type="text" placeholder="name" autocomplete="off" />
      <input type="text" placeholder="maker" autocomplete="off" />
      <input type="number" placeholder="price" autocomplete="off" />
      <input type="text" placeholder="condition" autocomplete="off" />
      <button>Add</button>
    </form>

    <form id="update-form">
      Update by id:
      <input type="number" placeholder="id" autocomplete="off" />
      <input type="text" placeholder="name" autocomplete="off" />
      <input type="text" placeholder="maker" autocomplete="off" />
      <input type="number" placeholder="price" autocomplete="off" />
      <input type="text" placeholder="condition" autocomplete="off" />
      <button>Add</button>
    </form>

    <form id="delete-form">
      Delete by id:
      <input type="number" placeholder="id" autocomplete="off" />
      <button>Delete</button>
    </form>

    <button id="refresh-btn">Refresh table</button>
    <table>
      <tr>
        <th>ID</th>
        <th>MAKER</th>
        <th>NAME</th>
        <th>PRICE</th>
        <th>CONDITION</th>
      </tr>
    </table>

    <button id="log-out">Log out</button>

    <script>
      (async () => {
        const tableEl = document.querySelector('table');

        const loginFormInputs = document.querySelectorAll('#login-form input');
        const loginBtn = document.querySelector('#login-form button');

        const addFormInputs = document.querySelectorAll('#add-form input');
        const addBtn = document.querySelector('#add-form button');

        const updateFormInputs = document.querySelectorAll(
          '#update-form input'
        );
        const updateBtn = document.querySelector('#update-form button');

        const deleteFormInputs = document.querySelectorAll(
          '#delete-form input'
        );
        const deleteBtn = document.querySelector('#delete-form button');

        loginBtn.addEventListener('click', async e => {
          e.preventDefault();
          const msg = document.createElement('p');
          const email = loginFormInputs[0].value;
          const password = loginFormInputs[1].value;
          loginFormInputs[0].value = '';
          loginFormInputs[1].value = '';

          try {
            const res = await fetch('http://52.170.37.60/users/login', {
              method: 'POST',
              headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
              body: `email=${email}&password=${password}`,
            });

            const token = await res.json();
            sessionStorage.setItem('token', token);

            msg.innerText = 'Success';
            document.getElementById('login-form').appendChild(msg);
            setTimeout(() => {
              document.getElementById('login-form').removeChild(msg);
              s;
            }, 3000);
          } catch (err) {
            msg.innerText = err;
            document.getElementById('login-form').appendChild(msg);
            setTimeout(() => {
              document.getElementById('login-form').removeChild(msg);
            }, 3000);
          }
        });

        addBtn.addEventListener('click', async e => {
          e.preventDefault();
          const msg = document.createElement('p');
          const token = sessionStorage.getItem('token');

          const name = addFormInputs[0].value;
          const maker = addFormInputs[1].value;
          const price = addFormInputs[2].value;
          const condition = addFormInputs[3].value;
          addFormInputs[0].value = '';
          addFormInputs[1].value = '';
          addFormInputs[2].value = '';
          addFormInputs[3].value = '';

          const item = {
            name,
            maker,
            price,
            condition,
          };

          try {
            if (!token) throw 'There is no token';
            const res = await fetch('http://52.170.37.60/admin/guitars', {
              method: 'POST',
              headers: { Authorization: token },
              body: JSON.stringify(item),
            });

            if (!name || !maker || !price || !condition)
              throw 'No empty field is allowed';

            const serverMsg = await res.text();
            console.log(serverMsg);

            msg.innerText = 'Success';
            document.getElementById('add-form').appendChild(msg);
            setTimeout(() => {
              document.getElementById('add-form').removeChild(msg);
            }, 3000);
          } catch (err) {
            msg.innerText = err;
            document.getElementById('add-form').appendChild(msg);
            setTimeout(() => {
              document.getElementById('add-form').removeChild(msg);
            }, 3000);
          }
        });

        updateBtn.addEventListener('click', async e => {
          e.preventDefault();
          const msg = document.createElement('p');
          const token = sessionStorage.getItem('token');

          const id = updateFormInputs[0].value;
          const name = updateFormInputs[1].value;
          const maker = updateFormInputs[2].value;
          const price = updateFormInputs[3].value;
          const condition = updateFormInputs[4].value;
          updateFormInputs[0].value = '';
          updateFormInputs[1].value = '';
          updateFormInputs[2].value = '';
          updateFormInputs[3].value = '';
          updateFormInputs[4].value = '';

          const res = await fetch(`http://52.170.37.60/guitars/${id || 0}`);
          const guitar = await res.json();
          console.log(guitar);

          const updatedItem = {
            name: name || guitar.name,
            maker: maker || guitar.maker,
            price: price || guitar.price,
            condition: condition || guitar.condition,
          };

          try {
            if (!token) throw 'There is no token';
            const res = await fetch(
              `http://52.170.37.60/admin/guitars/${id || 0}`,
              {
                method: 'PUT',
                headers: { Authorization: token },
                body: JSON.stringify(updatedItem),
              }
            );

            const serverMsg = await res.text();
            console.log(serverMsg);

            msg.innerText = 'Success';
            document.getElementById('update-form').appendChild(msg);
            setTimeout(() => {
              document.getElementById('update-form').removeChild(msg);
            }, 3000);
          } catch (err) {
            msg.innerText = err;
            document.getElementById('update-form').appendChild(msg);
            setTimeout(() => {
              document.getElementById('update-form').removeChild(msg);
            }, 3000);
          }
        });

        deleteBtn.addEventListener('click', async e => {
          e.preventDefault();
          const msg = document.createElement('p');
          const token = sessionStorage.getItem('token');

          const id = deleteFormInputs[0].value;
          deleteFormInputs[0].value = '';

          try {
            if (!token) throw 'There is no token';
            if (!id) throw 'No empty field is allowed';
            const res = await fetch(
              `http://52.170.37.60/admin/guitars/${id || 0}`,
              {
                method: 'DELETE',
                headers: { Authorization: token },
              }
            );

            const serverMsg = await res.text();
            console.log(serverMsg);

            msg.innerText = 'Success';
            document.getElementById('delete-form').appendChild(msg);
            setTimeout(() => {
              document.getElementById('delete-form').removeChild(msg);
            }, 3000);
          } catch (err) {
            msg.innerText = err;
            document.getElementById('delete-form').appendChild(msg);
            setTimeout(() => {
              document.getElementById('delete-form').removeChild(msg);
            }, 3000);
          }
        });

        const fillTableRow = guitar => {
          const row = document.createElement('tr');
          row.innerHTML = `
            <td>${guitar.id}</td>
            <td>${guitar.maker}</td>
            <td>${guitar.name}</td>
            <td>$${guitar.price}</td>
            <td>${guitar.condition}</td>
            `;

          tableEl.appendChild(row);
        };

        const fillTable = async () => {
          const response = await fetch('http://52.170.37.60/guitars');
          const guitarsData = await response.json();
          guitarsData.forEach(guitar => fillTableRow(guitar));
        };

        fillTable();

        document.getElementById('refresh-btn').addEventListener('click', () => {
          tableEl.innerHTML = `
            <tr>
                <th>ID</th>
                <th>MAKER</th>
                <th>NAME</th>
                <th>PRICE</th>
                <th>CONDITION</th>
            </tr>
            `;
          fillTable();
        });

        document.getElementById('log-out').addEventListener('click', () => {
          sessionStorage.removeItem('token');
        });
      })();
    </script>
  </body>
</html>
